#include "MQBasePlugin.h"

// CNX
class SeparateVertex : public MQSelectPlugin
{
public:
	SeparateVertex();
	virtual ~SeparateVertex();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

private:
	cmq::CMQDocument doc;
	cmq::CMQObject obj;

	BOOL separateVertex();
	BOOL separateLine();

	void make_maps(
		std::unordered_set<cmq::vindex_t> &vertexset,
		std::unordered_set<cmq::lindex_t> &lineset,
		std::unordered_multimap<cmq::vindex_t, cmq::lindex_t> &vtolmap,
		std::unordered_multimap<cmq::lindex_t, std::pair<cmq::findex_t, int>> &ltofmap);

	BOOL dist_groups(std::unordered_map<cmq::vindex_t, std::unordered_multimap<int, cmq::findex_t>> &groups,
		std::unordered_set<cmq::vindex_t> &vertexset,
		std::unordered_set<cmq::lindex_t> &lineset,
		std::unordered_multimap<cmq::lindex_t, std::pair<cmq::findex_t, int>> &ltofmap);

	BOOL make_faces(std::unordered_map<cmq::vindex_t, std::unordered_multimap<int, cmq::findex_t>> &groups);

};
